HDU - 1260 Tickets(dp)

24 篇文章 0 订阅

Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.

Input

There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:
1) An integer K(1<=K<=2000) representing the total number of people;
2) K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
3) (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.

Output

For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.

Sample Input

2
2
20 25
40
1
8

Sample Output

08:00:40 am
08:00:08 am

题意是给出一个N,N组样例,再给个k,代表k个人要买票,再给出k个数Si,表示每个人单独买票需要

的时间,再给出k-1个数Di,表示从第一个人开始,每两个相邻的人一起买票需要的时间。

很显然是到dp题,dp[i]表示第i个人买完票需要的最短时间,所以当前的时间,可以由上一个人买票的

时间加上当前人单个的时间转移得到,或者由上上个人,再加上上个人和当前人一起购买的时间得到;

转移方程即为dp[i] = min(dp[i - 1] + a[i], dp[i - 2] + b[i - 1]);

#include<iostream>
#include<stdio.h>
using namespace std;
int a[2010], b[2010], dp[2010];
int main(){
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		for(int i = 1; i <= n; i++)
			cin >> a[i];
		for(int i = 1; i < n; i++)
			cin >> b[i];
		int ans = 0; 
		b[0] = a[1]; // 第0个人和第一个人一起购买的时间即为第一个人单独购买的时间
		for(int i = 1; i <= n; i++)
		{
			dp[i] = min(dp[i - 1] + a[i], dp[i - 2] + b[i - 1]);
		}
		int h = 8 + dp[n] / 3600, m = dp[n] % 3600 / 60, s = dp[n] % 60;
		if(h >= 13)
		{
			h -= 12;
			printf("%02d:%02d:%02d pm\n", h, m, s);
		} 
		else
			printf("%02d:%02d:%02d am\n", h, m, s);
	}
	return 0;
}

 

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值